//
//  MyPrizeListVC.m
//  Open
//
//  Created by 雷俊博 on 2019/9/3.
//  Copyright © 2019 黄江涛 . All rights reserved.
//

#import "MyPrizeListVC.h"
#import "orderHeader.h"


#import "PrizeDetailInfoViewController.h"
#import "ListPrizeTableViewCell.h"
#import "JYEmpty.h"
#import "NoDataView.h"

#import "Constants.h"
#import "UIColor+Hex.h"


#import "CTAPIBaseManager.h"


static NSString * const identifier = @"identifier";
@interface MyPrizeListVC ()<UITableViewDataSource, UITableViewDelegate>
{
    orderHeader *_headView;
    BOOL _isup;
}
@property(nonatomic, strong, nonnull) UITableView *tableView;

@property (nonatomic, strong)orderHeader *headerView;

@property(nonatomic, strong, nullable) NSArray  *dataArray;

@property (nonatomic, strong, nullable)NSMutableArray *dataArry2;



@property (nonatomic, strong)CTAPIBaseManager *manager;


@end

@implementation MyPrizeListVC

#pragma mark - life cycle
- (void)viewDidLoad {
    [super viewDidLoad];
    [self createUI];
    // Do any additional setup after loading the view.
    
    [self.view addSubview:self.tableView];
    
    WeakSelf
    
    self.tableView.mj_header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
        //进行数据刷新操作
        [weakSelf loadData];
    }];
    
    // 马上进入刷新状态
    [self.tableView.mj_header beginRefreshing];
   
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    [JANALYTICSService startLogPageView:@"我的奖品"];
    [MobClick beginLogPageView:@"我的奖品"];
   
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    
    
    [JANALYTICSService stopLogPageView:@"我的奖品"];
    [MobClick endLogPageView:@"我的奖品"];
}

- (void)dealloc
{
    NSLog(@"MyPrizeListVc已释放");
}

-(void)createUI{
    self.view.backgroundColor=[UIColor whiteColor];
   
    
    UIView *back = [[UIView alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 42)];
    back.backgroundColor = [UIColor colorWithHex:0xd9d9d9 alpha:0.5];
    
  
    [self.view addSubview:back];
    [self.view addSubview:self.headerView];
    
    
  
    
}




- (void)loadData
{
    
    NSString *url = [NSString stringWithFormat:@"%@score/getwinRecord",CoinsBaseUrl];
    
    NSDictionary *dic = @{
                          @"userId":[NSNumber numberWithInteger:[getPeopleID PeopleID]],
                          @"telephone": [EnercryTool encryptUseDES:[getPeopleID PeopleIphoneNmber] key:DESKEY],
                          @"reqTimesTamp":[NSNumber numberWithInteger:[self getNowTimeTimestamp3]],
                          };
    
    
    NSArray *result = [dic.allKeys sortedArrayUsingComparator:^NSComparisonResult(id  _Nonnull obj1, id  _Nonnull obj2) {
        
        NSLog(@"%@~%@",obj1,obj2); //3~4 2~1 3~1 3~2
        
        
        
        
        return [obj1 compare:obj2]; //升序
        
    }];
    NSString *sign = nil;
    for (int i = 0; i < result.count; i++) {
        NSString *key = result[i];
        if (i==0) {
            sign = [NSString stringWithFormat:@"%@=%@",key,dic[key]];
        }else{
            
            sign = [NSString stringWithFormat:@"%@&%@=%@",sign,key,dic[key]];
        }
    }
    
    sign = [NSString stringWithFormat:@"%@&kk#d12",sign];
    
    NSMutableDictionary *params = [[NSMutableDictionary alloc]initWithDictionary:dic];
    
    NSString *signString = [[MyMD5 md5:sign] lowercaseString];
    [params setObject:signString forKey:@"sign"];
    
    WeakSelf
    
    
    

    [self.manager POSTWithUrl:url params:params success:^(id  _Nonnull responseObject) {

        [weakSelf.tableView.mj_header endRefreshing];
        if (responseObject) {
            NSNumber *code = responseObject[@"code"];
            NSString *des = responseObject[@"des"];
            if ([code isKindOfClass:[NSNumber class]]) {
                if (code.integerValue == 0) {
                    
                    [weakSelf.dataArry2 removeAllObjects];
                    NSArray *results = responseObject[@"result"];
                    
                    weakSelf.dataArray = results;
                    
                    
                    dispatch_async(dispatch_get_global_queue(0, 0), ^{
                        
                        for (int i = 0; i < results.count; i++) {
                            NSDictionary *dic = results[i];
                            if ([dic[@"lotterStatus"] isEqualToString:@"未领取"]) {
                                [weakSelf.dataArry2 addObject:dic];
                            }
                        }
                        
                        dispatch_async(dispatch_get_main_queue(), ^{
                            [weakSelf.tableView reloadData];
                            UIButton *btn = [weakSelf.headerView viewWithTag:79];
                            [btn setTitle:[NSString stringWithFormat:@"未领取(%ld)",weakSelf.dataArry2.count] forState:UIControlStateNormal];
                        });
                        
                    });
                    
                }else{
                    [SVProgressHUD showInfoWithStatus:des];
                }
            }else{
                [SVProgressHUD showInfoWithStatus:@"服务器错误"];
            }
        }
        
    } fail:^(NSError * _Nonnull error) {
        [weakSelf.tableView.mj_header endRefreshing];
        if (error.code == NSURLErrorTimedOut) {
            [SVProgressHUD showInfoWithStatus:@"请求超时"];
        }else if (error.code == NSURLErrorCancelled){
           // [SVProgressHUD showInfoWithStatus:@"取消请求"];
        }else if (error.code == NSURLErrorNotConnectedToInternet){
             [SVProgressHUD showInfoWithStatus:@"无网络"];
           
        }

    }];

}


#pragma mark - tableview datasourse delegate
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    if (self.index == 0) {
        if (self.dataArray.count != 0) {
            self.tableView.backgroundView = nil;
        }else{
            NoDataView *view = [[NoDataView alloc]initWithFrame:self.tableView.bounds];
            self.tableView.backgroundView = view;
        }
        
        return self.dataArray.count;
    }else{
        if (self.dataArry2.count != 0) {
            self.tableView.backgroundView = nil;
        }else{
            NoDataView *view = [[NoDataView alloc]initWithFrame:self.tableView.bounds];
            self.tableView.backgroundView = view;
        }
        
        return self.dataArry2.count;
    }
   
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    ListPrizeTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifier];
    
    if (self.index == 0) {
        [cell refreshUIWithData:self.dataArray[indexPath.row]];
    }else{
        [cell refreshUIWithData:self.dataArry2[indexPath.row]];
    }
    
    
    
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 100*WIDTHRADIU;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    PrizeDetailInfoViewController *detailVC = [[PrizeDetailInfoViewController alloc]init];
    
    NSDictionary *dic = nil;
    if (self.index == 0) {
        dic = self.dataArray[indexPath.row];
    }else{
        dic = self.dataArry2[indexPath.row];
    }
    
    if ([dic[@"giftId"] isEqualToString:@"1"]) {
        detailVC.type = CTListPrizeTypeCoins200;
    }else if ([dic[@"giftId"] isEqualToString:@"12"]) {
        detailVC.type = CTListPrizeTypeCoins388;
    }else if ([dic[@"giftId"] isEqualToString:@"13"]){
        detailVC.type = CTListPrizeTypeCoins588;
    }
    else if ([dic[@"giftId"] isEqualToString:@"9"]){
        detailVC.type = CTListPrizeTypePackage10;
    }else if ([dic[@"giftId"] isEqualToString:@"11"]){
        detailVC.type = CTListPrizeTypePackage2;
    }else if ([dic[@"giftId"] isEqualToString:@"10"]){
        detailVC.type = CTListPrizeTypePackage3;
    }else{
        detailVC.type = CTListPrizeTypeUnKnow;
    }
    if ([dic[@"lotterStatus"] isEqualToString:@"未领取"]) {
        detailVC.state = CTListPrizeStateUnGet;
    }else if ([dic[@"lotterStatus"] isEqualToString:@"发放中"]){
        detailVC.state = CTListPrizeStateGiving;
    }else if ([dic[@"lotterStatus"] isEqualToString:@"已领取"]){
        detailVC.state = CTListPrizeStateReceived;
    }else if ([dic[@"lotterStatus"] isEqualToString:@"已过期"]){
        detailVC.state = CTListPrizeStateInvalid;
    }else if ([dic[@"lotterStatus"] isEqualToString:@"领取失败"]){
        detailVC.state = CTListPrizeStateFailure;
    }else {
        detailVC.state = CTListPrizeStateUnKnow;
    }
    detailVC.title = @"奖品详情";
    detailVC.contentDic = dic;
    
    if (detailVC.type != CTListPrizeTypeUnKnow && detailVC.state != CTListPrizeStateUnKnow) {
        
        WeakSelf
        detailVC.clickBlock = ^(BOOL isCLick) {
            // 马上进入刷新状态
            [weakSelf.tableView.mj_header beginRefreshing];
        };
        [self.navigationController pushViewController:detailVC animated:YES];
    }else{
        [SVProgressHUD showInfoWithStatus:@"该奖励现无法查看,\n需更新版本"];
        return;
    }
    
}


#pragma mark - 获取当前时间戳

-(NSInteger )getNowTimeTimestamp3{
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init] ;
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss SSS"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    //设置时区,这个对于时间的处理有时很重要
    
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Beijing"];
    
    [formatter setTimeZone:timeZone];
    
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    
    NSInteger timeSp = [datenow timeIntervalSince1970]*1000;
    
    return timeSp;
}

#pragma mark - getters and setters
- (UITableView *)tableView {
    if (!_tableView){
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(0,  42, ScreenWidth, ScreenHeight - cl_kNavigationBarHeight - 42) style:UITableViewStylePlain];
        _tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        _tableView.dataSource = self;
        _tableView.delegate = self;
        _tableView.tableFooterView = [UIView new];
        [_tableView registerClass:[ListPrizeTableViewCell class] forCellReuseIdentifier:@"identifier"];
    }
    return _tableView;
}

- (orderHeader *)headerView
{
    if (!_headView) {
        _headView = [[orderHeader alloc]initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, 40)];
        _headView.backgroundColor = [UIColor whiteColor];
        _headView.items = @[@"全部奖品",@"未领取"];
        
        //消除强引用
        __weak typeof(self) weakSelf = self;
        
        _headView.itemClickAtIndex = ^(NSInteger index){
            
            weakSelf.index = index;
            
            [weakSelf.tableView reloadData];
            
        };
    }
    
    return _headView;
}



- (CTAPIBaseManager *)manager
{
    if (!_manager) {
        _manager  = [[CTAPIBaseManager alloc]init];
    }
    return _manager;
}

- (NSMutableArray *)dataArry2
{
    if (!_dataArry2) {
        _dataArry2 = [[NSMutableArray alloc]init];
    }
    return _dataArry2;
}


/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
